function CustomModal() {
	this.close_caption = '[x]';

	this.init = function() {
		this.wrapper = '<div class="qnvx-dialog-wrapper">';
		popup = this;
		$('html').append(
			$(this.wrapper).hide().fadeIn(300).click(function(e) {
				var senderElement = e.target;
				if($(e.target).is(".qnvx-dialog-wrapper")) {
					popup.closePopup();
				}
			})
		);
	}

	this.alert = function($msg, $heading = '') {
		this.init();
		var dialog = '<div class="qnvx-dialog"></div>';
		popup = this;

		$('.qnvx-dialog-wrapper').html(
			$(dialog).append(
				$('<div class="qnvx-dialog-head">' + $heading + '</div>')
				.append(
					$('<a href="#" class="qnvx-dialog-btn qnvx-dialog-close">' + popup.close_caption + '</a>').click(function() {
						popup.closePopup();
					})
				)
			)
			.append('<div class="qnvx-dialog-body">' + $msg + '</div>')
			.append(
				$('<div class="qnvx-dialog-foot"></div>').html(
					$('<button class="qnvx-dialog-btn">OK</button>').click(function() {
						popup.closePopup();
					})
				)
			)
		);
	};

	this.confirm = function($msg, callback, $heading = '', $btns = {}) {
		this.init();

		var btn_okay = 'Yes';
		var btn_cancel = 'No';

		if ($btns.ok) btn_okay = $btns.ok;
		if ($btns.cancel) btn_cancel = $btns.cancel;

		var dialog = '<div class="qnvx-dialog"></div>';
		popup = this;

		$('.qnvx-dialog-wrapper').html(
			$(dialog).append(
				$('<div class="qnvx-dialog-head">' + $heading + '</div>')
				.append(
					$('<a href="#" class="qnvx-dialog-btn qnvx-dialog-close">' + popup.close_caption + '</a>').click(function() {
						popup.closePopup();
					})
				)
			)
			.append('<div class="qnvx-dialog-body">' + $msg + '</div>')
			.append(
				$('<div class="qnvx-dialog-foot"></div>')
				.append(
					$('<button class="qnvx-dialog-btn">' + btn_okay + '</button>').click(function() {
						$('.qnvx-dialog-wrapper').fadeOut(500, function() {
							$(this).remove();
							callback();
						});
					})
				)
				.append(
					$('<button class="qnvx-dialog-btn">' + btn_cancel + '</button>').click(function() {
						popup.closePopup();
					})
				)
			)
		);
	};

	this.prompt = function($msg, callback ,$heading = '') {
		this.init();
		var dialog = '<div class="qnvx-dialog"></div>';
		popup = this;

		$('.qnvx-dialog-wrapper').html(
			$(dialog).append(
				$('<div class="qnvx-dialog-head">' + $heading + '</div>')
				.append(
					$('<a href="#" class="qnvx-dialog-btn qnvx-dialog-close">' + popup.close_caption + '</a>').click(function() {
						popup.closePopup();
					})
				)
			)
			.append('<div class="qnvx-dialog-body">' + $msg + '</div>')
			.append(
				$('<div class="qnvx-dialog-foot"></div>')
				.append('<input type="text" class="qnvx-dialog-input">')
				.append(
					$('<button class="qnvx-dialog-btn">OK</button>').click(function() {
						popup.closePopup();

						input = $('.qnvx-dialog-input').val();
						callback(input);
					})
				)
			)
		);
	};

	this.closePopup = function() {
		if ($('.qnvx-dialog-wrapper').length) {
			$('.qnvx-dialog-wrapper').fadeOut(300, function() {
				$(this).remove();
			});
		}
	}
}

var dialog = new CustomModal();
